package edu.berkeley.cs160.teammoomoo.nutritrak160;

import java.util.Enumeration;
import java.util.Hashtable;

import edu.berkeley.cs160.teammoomoo.nutritrak160.NutriTrakDdAdapter.MealStruct;
import edu.berkeley.cs160.teammoomoo.nutritrak160.NutriTrakDdAdapter.NutrientEntry;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.view.Menu.Item;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.content.Context;

/**
 * View to see food details.
 * @author Brandon
 *
 */

public class FoodView extends Activity {
	public static final int DEFAULT_MEAL = 1;
	public static final String MEAL_NUTRIENTS_STR= 
		"Nutritional Facts for %s\n%s";
	private TextView meal_nutrients;
	private int	mMealId;	
	private NutriTrakDdAdapter mDbHelper;

	
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setContentView(R.layout.meal);
        meal_nutrients = (TextView) findViewById(R.id.meal_nutrients);
        findViewById(R.id.meal_info).setVisibility(View.GONE);
        mDbHelper = new NutriTrakDdAdapter(this);
        mDbHelper.open();
        
        Bundle extras = icicle!=null?icicle:getIntent().getExtras();
        if (extras == null)
        {
        	Log.d("FoodView", "Chose default meal");
        	mMealId = DEFAULT_MEAL;
        }
        else {
        	mMealId = extras.getInt(NutriTrakDdAdapter.KEY_FOOD_ID);
        	Log.d("FoodView", "Retrieve from bundle: " + mMealId);
        }

        Button b = (Button) findViewById(R.id.view_meal_edit);
        Button bd = (Button) findViewById(R.id.view_meal_done);
        
        b.setVisibility(View.GONE);
		bd.setVisibility(View.GONE);
		findViewById(R.id.scroll_view).setLayoutParams(
				new LinearLayout.LayoutParams(
						ViewGroup.LayoutParams.FILL_PARENT, 
						ViewGroup.LayoutParams.FILL_PARENT));
        
        Hashtable<String, Integer> stats = mDbHelper.getStatsOfFood(mMealId);        
        Enumeration<String> e = stats.keys();
        String nutrients = "";
        while(e.hasMoreElements()){
        	String  nutrient = e.nextElement();
        	int     total = stats.get(nutrient);
        	NutrientEntry unit = mDbHelper.nutrientEntries.get(nutrient);
        	nutrients += String.format("\t%s: %s\n", nutrient, unit.convert(total));
        }
        String food_name = mDbHelper.fromFoodIDtoName(mMealId);
        meal_nutrients.append(String.format(MEAL_NUTRIENTS_STR, food_name, nutrients)); 
    }
    
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		return GlobalMenu.createContextMenu(menu);
	}

	@Override
	public boolean onMenuItemSelected(int featureId, Item item) {
		return GlobalMenu.handleMenuItemSelect(featureId, item, this)?
				true:super.onMenuItemSelected(featureId, item);
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, 
			String data, Bundle extras) {
		super.onActivityResult(requestCode, resultCode, data, extras);
		
		if(data != null && data.equalsIgnoreCase("chain")) {
			setResult(RESULT_OK, "chain");
			this.finish();
		}
	}
	
	@Override
	protected void onFreeze(Bundle outState) {
		// TODO Auto-generated method stub
		outState.putInt(NutriTrakDdAdapter.KEY_MEAL_ID, mMealId);
		
		super.onFreeze(outState);
	}
}
