package edu.berkeley.cs160.teammoomoo.nutritrak160;

import android.os.SystemClock;
import android.util.TimeUtils;
import android.app.Activity;
import android.app.TimePickerDialog;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.view.Menu.Item;

import java.io.*;

/**
 * @author Bruno, Ben
 */

public class GlobalMenu {
	
	public static final int CREATE_ID = 0;
	public static final int LOOKUP_ID = 1;
	public static final int ADDEXERCISE_ID = 2;
	public static final int HISTORY_ID = 3;
	public static final int PREFERENCES_ID = 4;
	public static final int VIEWMEAL_ID = 5;
	public static final int MAINVIEW_ID = 6;
	public static final int EDITMEAL_ID = 7;
	
	private static int mCurrentView = MAINVIEW_ID;
	
	public static void backToMain() {
		mCurrentView = MAINVIEW_ID;
	}
	
	public static boolean createContextMenu(Menu menu) {
		if(mCurrentView!=MAINVIEW_ID)
			menu.add(0, MAINVIEW_ID, R.string.main);
		if(mCurrentView!=CREATE_ID)
			menu.add(0, CREATE_ID, R.string.create_meal);
		if(mCurrentView!=LOOKUP_ID)
			menu.add(0, LOOKUP_ID, R.string.lookup_food);
		if(mCurrentView!=ADDEXERCISE_ID)
			menu.add(0, ADDEXERCISE_ID, R.string.add_exercise);
		if(mCurrentView!=HISTORY_ID)
			menu.add(1, HISTORY_ID, R.string.history);
		if(mCurrentView!=PREFERENCES_ID)
			menu.add(1, PREFERENCES_ID, R.string.preferences);
		return true;
	}
	
	public static boolean handleMenuItemSelect(int featureId, Item item, Activity a){
		Intent i;
		switch(item.getId()) {
		case MAINVIEW_ID:
			i = new Intent(a, MainView.class);
			mCurrentView = MAINVIEW_ID;
			//a.startSubActivity(i, MAINVIEW_ID);
			a.setResult(Activity.RESULT_OK, "chain");
			a.finish();
			return true;
		case CREATE_ID:
			i = new Intent(a, SearchView.class);
			mCurrentView = CREATE_ID;
			i.putExtra(SearchView.KEY_CREATE_MEAL, true);
			a.startSubActivity(i, CREATE_ID);
			return true;
		case LOOKUP_ID:
			mCurrentView = LOOKUP_ID;
			i = new Intent(a, SearchView.class);
			i.putExtra(SearchView.KEY_CREATE_MEAL, false);
			a.startSubActivity(i, LOOKUP_ID);
			return true;
		case ADDEXERCISE_ID:
			mCurrentView = ADDEXERCISE_ID;
			i = new Intent(a, AddExerciseView.class);
			a.startSubActivity(i, ADDEXERCISE_ID);
			return true;
		case HISTORY_ID:
			mCurrentView = HISTORY_ID;
			i = new Intent(a, HistoryView.class);
			a.startSubActivity(i, HISTORY_ID);
			return true;
		case PREFERENCES_ID:
			mCurrentView = PREFERENCES_ID;
			i = new Intent(a, PreferencesView.class);
			a.startSubActivity(i, PREFERENCES_ID);
			return true;
		}
		return false;
	}
}
