package edu.berkeley.cs160.teammoomoo.nutritrak160;

import java.util.*;
import java.sql.Time;
import java.sql.Date;
import java.sql.Timestamp;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.util.DateFormat;
import android.util.Log;
import android.database.Cursor;

/**
 * To be used for the purposes of quickly testing database and other
 * experimental objects and methods that we're not sure will work
 * properly.
 * 
 * Note: this class is no longer being regularly run, might have issues
 * 
 * @author Ben
 */
public class TestView extends Activity {
	/** Print your results at the outputArea textview so you can confirm that 
	 * they match your expectations before relying on them in real code.
	 */
	TextView text;
	
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setContentView(R.layout.test);
        this.text = (TextView) findViewById(R.id.outputArea);
    }

	@Override
	protected void onResume() {
		super.onResume();
		
		// Test Time utility methods
		Date sqlDateObj = Utils.getDate();
		Time sqlTimeObj = Utils.getTime();
		Timestamp sqlTimestampObj = Utils.getTimeStamp();
		
		String dateString = sqlDateObj.toString();
		String timeString = sqlTimeObj.toString();
		String timestampString = sqlTimestampObj.toString();
		
		text.setText(dateString+"\n"+timeString+"\n"+timestampString+"\n");
		
		// Database methods test
		NutriTrakDdAdapter dbAdapter = new NutriTrakDdAdapter(this);
		dbAdapter.open();
        text.append(dbAdapter.getTopLevelCategories().toString()+"\n");
        text.append(dbAdapter.getCategoryChildrenOfCategory("pie").toString()+"\n");
        text.append(dbAdapter.getFoodChildrenOfCategory("fruit pie").toString()+"\n");
        text.append(dbAdapter.isFood("blueberry pie") ? "Blueberry pie is a food" : "Test failure");
        text.append("\n");
        int blueBerryID = dbAdapter.fromFoodNameToID("blueberry pie");
        text.append("The ID for blue berry pie is " + blueBerryID + "\n");
        Utils.assertTrue(dbAdapter.fromFoodIDtoName(blueBerryID).equals("blueberry pie"));
        Utils.assertFalse(dbAdapter.isFood("soda"));
        Cursor foodCursor = dbAdapter.getFoods();
//        while (foodCursor.next()) {
//        	String foodName = foodCursor.getString(1);
//        	text.append(foodName + " ");
//        }
        // Takes up too much of screen
        text.append("\n");
        Hashtable blueBerryPieStats = dbAdapter.getStatsOfFood("blueberry pie");
        Enumeration nutriEnum = blueBerryPieStats.keys();
        while (nutriEnum.hasMoreElements()) {
        	String nutriKey = (String) nutriEnum.nextElement();
        	text.append(nutriKey+":"+blueBerryPieStats.get(nutriKey)+" ");
        }
        text.append("\n");
        int orangeJuiceID = dbAdapter.fromFoodNameToID("orange juice");
        Utils.assertTrue(dbAdapter.fromFoodIDtoName(orangeJuiceID).equals("orange juice"));
        LinkedList<Integer> foods = new LinkedList<Integer>();
        foods.add(blueBerryID); foods.add(orangeJuiceID);
        LinkedList<Integer> quantities = new LinkedList<Integer>();
        quantities.add(1); quantities.add(2);        
        GregorianCalendar cal = new GregorianCalendar();
        long mealID = dbAdapter.createMeal(foods, quantities);
        int[] mealsConsumed = dbAdapter.getConsumedMealsOnDate(cal);
        Utils.assertTrue(mealsConsumed.length == 2);
        Hashtable total = dbAdapter.getTotalStatsOfDay(cal);
        Enumeration e = total.keys();
        while (e.hasMoreElements()) {
        	String nutrient = (String) e.nextElement();
        	text.append(nutrient + ":" + total.get(nutrient)+"\n");
        }
        Log.d("TestView", dbAdapter.getTimeOfConsumption((int)mealID));
		dbAdapter.close();
		
		// Next test goes here
	}
}
